unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    RadioGroup1: TRadioGroup;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    function  InttoByteSTR(Value, Tam: integer):String;
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  port: integer;
  ByteToSend: Byte;

implementation

{$R *.dfm}

function inportb(EndPorta: Integer): BYTE stdcall; external 'inpout32.DLL' name 'Inp32';
procedure outportb(EndPorta: Integer; Valor:BYTE); stdcall; external 'inpout32.DLL' name 'Out32';

function  TForm1.InttoByteSTR(Value, Tam: integer):String;
var
  x: integer;
  temp: string;
begin
  temp := '';
  setlength(result, 8);

  while (value >= 1 ) do
    begin
      temp := temp + inttostr(value mod 2);
      value := value div 2;
    end;

  if length(temp) > Tam then
    begin
      showmessage('erro! Numero passado tem mais que a quantidade de bits estipulada');
    end
  else
    begin
      for x:= 1 to 8 do
        begin
          if (length(temp) < x) then
            result[9 - x] := '0'
          else
            result[9 - x] := temp[x];
        end;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  porta, valor: integer;
begin
try
 begin
  if radiogroup1.ItemIndex = 0 then
    begin
      Label2.Caption := InttoByteSTR(strtoint(edit1.Text), 8);
      porta := $378;
      valor := inttostr(Edit1.Text);
    end
  else if Radiogroup1.ItemIndex = 1 then
    begin
      Label3.Caption := InttoByteSTR(strtoint(edit1.Text), 8);
      porta := $37A;
    end
  else
    begin
      showmessage('Escolha para qual porta deseja mandar um valor antes de ligar o programa!');
    end;
  outportb(porta, valor);
 end;
except
  on E: EConvertError do
    begin
      Showmessage('Esse texto no corresponde a um valor inteiro vlido. Digite novo valor!');
    end;
 end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    1:
      port := $37A;
    0:
      port := $378;
  end;
end;

end.
